﻿---------------------------------------
---------------------------------------------------
--CustomRez
--Author : Fannia (Lothar US)
--Description : Sends funny random messages or a simple useful message when you use a resurrection spell.
--Inspired by : Serenity (messages and main idea), Necrosis (function to substitute names in messages)
--Credits : Lomig (Kael'Thas EU/FR) & Tarcalion (Nagrand US/Oceanic) -> Necrosis
--          Algarana - Rashgaroth ( EU - Alliance ) & Kaeldra of Aegwynn -> Serenity
-- **analysing your code was a pain, but i thank you for the inspiration and random messages ;)**

--Dev notes : need a way to switch texture on activation and random buttons to show the current state.
----------------------------------------------------
----------------------------------------------------

--Set up table
CustomRez={}

-----------------------------------------------------
--on load function
function CustomRez.OnLoad(frame)
	CustomRezFrame:RegisterEvent("VARIABLES_LOADED")
	frame:RegisterForDrag("LeftButton")
end

----------------------------------------------------
--Setting up the needed variables
function CustomRez.SetVars()
	if CustomRezVars==nil then
		local class,baseclass=UnitClass("player")
		CustomRezVars={
			SimpleMessage=true,
			Activated=true,
			ChannelWanted="SAY",
			Class=class,
			}
	end
	
	--set up the buttons' texture
	if CustomRezVars.SimpleMessage==false then
		CrezRandomToggleButton:SetNormalTexture("Interface\BUTTONS\UI-GroupLoot-Dice-Highlight")
		CrezRandomToggleButton:Show()
		--print("Dice ok")
	end
	if CustomRezVars.Activated==true then
		CrezActivate:SetNormalTexture("Interface\BUTTONS\UI-CheckBox-Check")
		--print("check ok")
	elseif CustomRezVars.Activated==false then
		CrezActivate:SetNormalTexture("Interface\BUTTONS\UI-GroupLoot-Pass-Up")
		--print("check ok")
	end
	
	--semi-localization
	local priest_rez=GetSpellInfo(2006)
	local pally_rez=GetSpellInfo(7328)
	local shammy_rez=GetSpellInfo(2008)
	local druid_rez=GetSpellInfo(50769)
	CustomRez.Spelltbl={
		["PRIEST_REZ"]=priest_rez,
		["PALLY_REZ"]=pally_rez,
		["SHAMMY_REZ"]=shammy_rez,
		["DRUID_REZ"]=druid_rez,
		}
	
	
	--RANDOM MESSAGES--
	--here you can change the messages to your liking. always keep the current format or it wont work. if you want to include your class, either write it literaly or check message #17. don't forget the commas ( , ) after each messages, even the last. check wowwiki.com for usable characters and special characters.
	CustomRez.RESURECTION = {
       	"Granddaddy always said laughter was the best medicine. I guess it wasn't strong enough to keep <target> alive.",
		"Okay, <target>, nap time is over! Back to work!",
		"Rezzing <target>. Can I get an 'amen', please!",
		"<target>, your subscription to Life(tm) has expired. Do you wish to renew?",
		"YAY! I always wanted my very own <target>-zombie!",
		"It just so happens that <target> is only MOSTLY dead. There's a big difference between mostly dead and all dead. Mostly dead is slightly alive.",
		"<target> has failed at life, I'm giving him a second chance. That's right, not God, ME!!",
		"Cool, I received 42 silver, 32 copper from <target>'s corpse",
		"GAME OVER, <target>. To continue press up, up, down, down, left, right, left, right, B, A, B, A, Select + Start",
		"<target>, it's more mana efficient just to resurrect you.  Haha, I'm just kidding!",
		"Well, <target>, if you had higher faction with Then Engineers of Polytechnique of Montreal, you might have gotten a heal.  How do you raise it?  10g donation = 15 rep.",
		"Okay, <target>.  Stop being dead. No really, i insist.",
		"If you are reading this message, <target> is already dead.",
		"Don't rush me <target>. You rush a miracle worker, you get rotten miracles.",
		"Death came for you <target>! with large, pointy teeth! did you not see it?",
		"Resurrecting <target>. Side effects may include: nausea, explosive bowels, a craving for brains, and erectile dysfunction. Resurrection is not for everyone. Please consult healer before dying.",
		"Dammit <target>, I'm a doctor! Not a "..CustomRezVars.Class.."! .... Wait a second.... Nevermind. Rezzing <target>",
		"Dying makes me angry, <target>, so you'd better stop now before I KILL YOU THEN REZ YOU THEN HIT THE *LOOP* BUTTON!",
		"<target> stop worshipping the ground I walk on and get up." ,
		"Hey <target>, will you check to see if Elvis is really dead?...and will he fill your spot in the party?",
		"Giving <target> another chance to mess it up. Yes i know i'm too generous.",
		"Dammit, <target>, did you get my PERMISSION before dying?! You gotta fill in form A-23WTF-ZOMG6-10KDM-REZME911 and send it by mail with a 100g cheque to my office 2 weeks prior to you death.",
		"Death defying feats are clearly not your strong point, <target>",
		"No way, i ain't burying you here, <target>.I'm much too important to get my nails dirty.",
		"<target>, by accepting this resurrection you hereby accept that you must forfeit your immortal soul to <player>. Please click 'Accept' to continue.",
		"<target>, this better not be another attempt to get me to give you mouth-to-mouth.",
		"Arise <target>, and fear death no more...or at least until the next pull.",
		"Stop slacking, <target>. You can sleep when you're dea... Oh... Um, rezzing <target>",
		"We can rebuild <target>. We can make him stronger, faster, but we can't make him any smarter.",
		"<target> has fallen and can't get up! What do you mean he broke his 2 legs? No excuse sir!",
		"Bring out your dead! *throws <target> on the cart*",
		"<player> said : *<target>, get up and walk* and <target> did.",
		"<target>, quit hitting on the Spirit Healer and come kill something!",
		"<target> I *warned* you, but did you listen to me? Oh, no, you *knew*, didn't you? Oh, it's just a harmless little *bunny*, isn't it?",
		"<target>, please! This is supposed to be a happy occasion. Let's not bicker and argue over who killed who.",
		"Today's category on Final Jeopardy: Spells that end in 'esurrection'. <target>, ready?",
		"There are worse things then death, <target>. Have you ever grouped with... oh, wait. We aren't supposed to mention that in front of you.",
		"Did you run into some snakes on a plane or something, <target>? 'cause you're dead.",
		"Wee-ooo! Wee-ooo! Wee-ooo! Wee-ooo! Wee-ooo! Wee-ooo... that's the best ambulance impression I can do, <target>.",
		"Tsk tsk, <target>. See, I told you to sacrifice that virgin to the Volcano God.",
		"<target> gets a Mulligan.",
		"Sorry <target>, i can't heal stupidity. I can rez stupid tought.",
		"Eww!  What's that smell!  It smells like something died in here!  Hey, where is <target>?... Oh.",
		"Unfortunately, <target>, you have to be at least Revered with Polytechnique of Montreal Engineers to be rezzed. Sucks to be you.",  
		"You don't deserve a cute rez macro, <target>. You deserve to die. But you already did, so, um... yeah.",
		"<target>, you have been weighed, you have been measured, and too bad, there wasn't any coffin we could fit you in so apparently you can't die yet.",
		"Well <target>, you tried your best...and apparently failed miserably. Good job.", 
		"Did it hurt, <target>, when you fell from Heaven? Oh, wait...You're dead...hmmm...I don't know where I was going with that. Nevermind.", 
		"Gah, <target>, dead again? You probably want a rez, don't you? What do you think I am, a "..strsub(CustomRezVars.Class,1,3).."... oh. Fair enough.",
		"<target> have you heard of Nethaera?  Yeah, she's really cool.  Why do I bring it up?  No reason.",
		"Can somebody get <target> a Phoenix Down over here? *stumbles* Wow, out of body experience...",
		"Funny how everyone else can die and come back, but a Phoenix Down won't take care of <target>.",
		"Sorry <target>, I know I'm a "..CustomRezVars.Class.." ... but come ON! Did you see how many guys there were!?",
		"Hey <target>! Don't go towards the light! Well, unless it says 'Accept' ... but even then, it might be a trick!",
		"Sorry <target>, I couldn't heal you. I was too busy being the tank.",
		"<target>, prove me i'm not making a mistake by rezzing you...",
		"You're lucky i like you <target>",
		"Rezzing <target> before he gets a tea-bag from everyone in the group. Oups...too late :p",
		"Haiku time!\nThere was a monster\n<target> stood there\n<Player> rezzed <target>.",
		"You know <target>, as much as i hate to say it, watching you die made me smile, laugh, hug my cat, adopt an orphan and reach a higher elevation of the mind. You are worthy to come back.",
		}
end

--------------------------------------------------------
--button and frames fonctions

--drop down menu

function CustomRez.InitializeDropDown(level)
	local info={}
	
	info.text="say"
	info.isTitle=nil
	if CustomRezVars==nil or CustomRezVars.ChannelWanted=="SAY" then
		info.checked=not somesetting1
	else
		info.checked=somesetting1
	end
	function info.func()
		CustomRezVars.ChannelWanted="SAY"
	end
	UIDropDownMenu_AddButton(info)
	
	info.text="yell"
	if CustomRezVars==nil or  CustomRezVars.ChannelWanted=="YELL" then
		info.checked=not somesetting2
	else
		info.checked=somesetting2
	end
	function info.func()
		CustomRezVars.ChannelWanted="YELL"
	end
	UIDropDownMenu_AddButton(info)

	info.text="party"
	if CustomRezVars==nil or  CustomRezVars.ChannelWanted=="PARTY" then
		info.checked=not somesetting3
	else
		info.checked=somesetting3
	end
	function info.func()
		CustomRezVars.ChannelWanted="PARTY"
	end
	UIDropDownMenu_AddButton(info)

	info.text="raid"
	if CustomRezVars==nil or  CustomRezVars.ChannelWanted=="RAID" then
		info.checked=not somesetting4
	else
		info.checked=somesetting4
	end
	function info.func()
		CustomRezVars.ChannelWanted="RAID"
	end
	UIDropDownMenu_AddButton(info)
end

function CustomRez.SpeechDropDownOnLoad(self)
	UIDropDownMenu_Initialize(self,CustomRez.InitializeDropDown);
end

function CustomRez.SpeechButtonOnClick(self,button,down)
	ToggleDropDownMenu(1,nil,CRezSpeechDropDownMenu,self:GetName(), 0, 0)
end


--dice button
function CustomRez.RandomToggleOnClick(self,button,down)
	if CustomRezVars.SimpleMessage==true then
		CustomRezVars.SimpleMessage=false
		SELECTED_CHAT_FRAME:AddMessage("CustomRez: random message active")
		self:SetNormalTexture("Interface\BUTTONS\UI-GroupLoot-Dice-Highlight")
	else
		CustomRezVars.SimpleMessage=true
		self:SetNormalTexture("Interface\BUTTONS\UI-GroupLoot-Dice-Up")
		SELECTED_CHAT_FRAME:AddMessage("CustomRez: simple message active")
	end
end

--hide button
function CustomRez.HideButtonOnClick(self,button,down)
	CustomRezFrame:Hide()
end

--activation button
function CustomRez.ActivationButtonOnClick(self,button,down)
	if CustomRezVars.Activated==true then
		CustomRezFrame:UnregisterEvent("UNIT_SPELLCAST_SENT")
		SELECTED_CHAT_FRAME:AddMessage("CustomRez: desactivated")
		CustomRezVars.Activated=false
		CrezActivate:SetNormalTexture("Interface\BUTTONS\UI-GroupLoot-Pass-Up")
	elseif CustomRezVars.Activated==false then
		CustomRezFrame:RegisterEvent("UNIT_SPELLCAST_SENT")
		SELECTED_CHAT_FRAME:AddMessage("CustomRez: activated")
		CustomRezVars.Activated=true
		CrezActivate:SetNormalTexture("Interface\BUTTONS\UI-CheckBox-Check")
	end
end

-----------------------------------------------------
--tooltips function

function CustomRez.ShowToolTip(element,buttonID)
	GameTooltip:ClearLines()
	GameTooltip:SetOwner(element,"ANCHOR_BOTTOMLEFT")
	if buttonID == 1 then
		GameTooltip:AddLine("Activate button")
		GameTooltip:AddLine("Toggles on/off")
	elseif buttonID == 2 then
		GameTooltip:AddLine("Speech button")
		GameTooltip:AddLine("Set Prefered Channel")
	elseif buttonID==3 then
		GameTooltip:AddLine("Random button")
		GameTooltip:AddLine("Toggle random/simple")
	elseif buttonID==4 then
		GameTooltip:AddLine("Hide button")
		GameTooltip:AddLine("Type /crez show to get it back")
	end
	GameTooltip:Show()
end
		
-----------------------------------------------------
-- Set up the slash command

SlashCmdList["CustomRez"] = function ( msg )
		CustomRez.DoSlash( msg );
	end

SLASH_CustomRez1 = "/customrez";
SLASH_CustomRez2 = "/crez";

------------------------------------------------------

-- functions associated with Slash commands
function CustomRez.DoSlash( msg )
	if ( not msg or msg == "" ) then
		CustomRez.ShowUsage();
	end
	local words = {};
	for word in string.gmatch( msg, "[^ ]+" ) do
		table.insert( words, word );
	end
	local cmd = words[1];
	if cmd=="on" then
		--turn on
		CustomRezVars.Activated=true
		CustomRezFrame:RegisterEvent("UNIT_SPELLCAST_SENT")
		SELECTED_CHAT_FRAME:AddMessage("CustomRez: activated")
	elseif cmd=="off" then
		--turn off
		CustomRezVars.Activated=false
		CustomRezFrame:UnregisterEvent("UNIT_SPELLCAST_SENT")
		SELECTED_CHAT_FRAME:AddMessage("CustomRez: desactivated")
	elseif cmd=="show" then
		if not CustomRezFrame:IsVisible() then
			CustomRezFrame:Show()
		end
	elseif cmd=="hide" then
		if CustomRezFrame:IsVisible() then
			CustomRezFrame:Hide()
		end
	elseif cmd=="simple" then
		--use simple message
		CustomRezVars.SimpleMessage=true
		SELECTED_CHAT_FRAME:AddMessage("CustomRez: simple message active")
	elseif cmd=="random" then
		--ude random messages
		CustomRezVars.SimpleMessage=false
		SELECTED_CHAT_FRAME:AddMessage("CustomRez: random messages active")
	elseif cmd=="say" or cmd=="party" or cmd=="raid" or cmd=="yell" then
		--set prefered channel
		CustomRezVars.ChannelWanted=string.upper(cmd)
		CustomRez.SetChannel()
		SELECTED_CHAT_FRAME:AddMessage("CustomRez will now display in "..cmd.." if possible")
	else
		--show help
		CustomRez.ShowUsage();
	end
end

----------------------------------------------------
--Checks preffered channel and depending on situation, automatically sets it to the next logcal channel raid -> party -> say
function CustomRez.SetChannel()
	if CustomRezVars.ChannelWanted=="RAID" and GetRealNumRaidMembers()==0 then
		if GetRealNumPartyMembers() > 0 then
			CustomRez_channel="PARTY"
			--SELECTED_CHAT_FRAME:AddMessage("auto switch to party from raid");
		else
			CustomRez_channel="SAY"
			--SELECTED_CHAT_FRAME:AddMessage("auto switch to say from raid");
		end
	elseif CustomRezVars.ChannelWanted=="PARTY" and GetRealNumPartyMembers()==0 then
		CustomRez_channel="SAY"
		--SELECTED_CHAT_FRAME:AddMessage("auto switch to say from party");
	else
		CustomRez_channel=CustomRezVars.ChannelWanted
	end
	--print("Channel set")
end

------------------------------------------------------	
--the help messages
function CustomRez.ShowUsage()
	SELECTED_CHAT_FRAME:AddMessage("CustomRez by Fannia. Messages in most part from Serenity")
	SELECTED_CHAT_FRAME:AddMessage("Available commands are :");
	SELECTED_CHAT_FRAME:AddMessage(" - on : activate CustomRez messages");
	SELECTED_CHAT_FRAME:AddMessage(" - off : desactive CustomRez messages");
	SELECTED_CHAT_FRAME:AddMessage(" - simple : use simple rez messages");
	SELECTED_CHAT_FRAME:AddMessage(" - random : use random and elaborate messages");
	SELECTED_CHAT_FRAME:AddMessage(" - say, yell, party, raid : sets the prefered channel. if channel is unavailable, uses the next logical channel. i.e if you choose raid but you're only in a party, it will display in party chat. if you aren't even in a party, it will display in say");
end



--the display channel
CustomRez_channel=""

-----------------------------------------------------
--core of it

function CustomRez.OnEvent(frame,event,...)
	local unitId,spell,rank,target = ...
	--print(event)
	if event=="VARIABLES_LOADED" then
		CustomRez.SetVars()
		if CustomRezVars.Activated == true then
			CustomRezFrame:RegisterEvent("UNIT_SPELLCAST_SENT")
			--print("Activated")
		end
		CustomRezFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
		CustomRezFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
	elseif event=="PLAYER_REGEN_ENABLED" and CustomRezVars.Activated==true then
		CustomRezFrame:RegisterEvent("UNIT_SPELLCAST_SENT")
		--SELECTED_CHAT_FRAME:AddMessage("exit combat. UNIT_SPELLCAST_SENT ACTIVATED");
	elseif event=="PLAYER_REGEN_DISABLED" and CustomRezVars.Activated==true then
		CustomRezFrame:UnregisterEvent("UNIT_SPELLCAST_SENT")
		--SELECTED_CHAT_FRAME:AddMessage("entered combat. UNIT_SPELLCAST_SENT DESACTIVATED");
	elseif event=="UNIT_SPELLCAST_SENT" then
		--print(unitID,spell,rank,target)
		--SELECTED_CHAT_FRAME:AddMessage("casting"..spell);
		
		--WHY DOESN'T IT WORK WITH REVIVE?!!
		if spell==CustomRez.Spelltbl.PRIEST_REZ or spell ==CustomRez.Spelltbl.SHAMMY_REZ or spell==CustomRez.Spelltbl.PALLY_REZ or spell==CustomRez.Spelltbl.DRUID_REZ then
			--print("spell recognized");
			if CustomRezVars.SimpleMessage==true then
				--SELECTED_CHAT_FRAME:AddMessage("simple message");
				CustomRez.SimpleRezMsg(spell,target)
			elseif CustomRezVars.SimpleMessage==false then
				--SELECTED_CHAT_FRAME:AddMessage("random message");
				CustomRez.RandomRezMsg(target)
			end
		end
	end
end

------------------------------------------------------
--sends a boring normal message...for boring normal people
function CustomRez.SimpleRezMsg(spell,target)
	CustomRez.SetChannel()
	if target==nil then
		target="Player-who-has-released"
	end
	--SELECTED_CHAT_FRAME:AddMessage("channel: "..CustomRez_channel.."  target: "..target);
	SendChatMessage("Casting "..spell.." on "..target, CustomRez_channel)
end

--Sends a funny random message from the table up there
function CustomRez.RandomRezMsg(target)
	CustomRez.SetChannel()
	if target==nil then
		target=""
	end
	--where the randomness takes place
	local randmsg, r,l = "",0,0
	l=#CustomRez.RESURECTION
	r=math.random(l)
	randmsg=CustomRez.RESURECTION[r]
	randmsg=CustomRez.MsgReplace(randmsg, target)
	--SELECTED_CHAT_FRAME:AddMessage("lenght table : "..tostring(l));
	--SELECTED_CHAT_FRAME:AddMessage("random number : "..tostring(r));
	--SELECTED_CHAT_FRAME:AddMessage("channel : "..CustomRez_channel);
	SendChatMessage(randmsg,CustomRez_channel)
end

-------------------------------------------------------------
--replaces the <target> and <player> in messages by actual target name and player name. if no target or target is unknown, means that player has already released. changes <target> to Player-who-has-released.
function CustomRez.MsgReplace(msg, target)
	msg = msg:gsub("<player>", UnitName("player"))
	if target == "" or target=="Unknown" then
		msg = msg:gsub("<target>", "Player-who-has-released")
	else
		msg = msg:gsub("<target>", target)
	end
	return msg
end